#import <Cocoa/Cocoa.h>

#include <EGL/egl.h>
#include <GLES2/gl2.h>

#include "glesclient.h"

/**
 * The ARMGLESView provides a surface onto which the output of emulated OpenGL
 * ES commands can be drawn. 
 */
@interface ARMGLESView : NSView {
		GLESClient *_glesClient;

    /** The EGL display. */
    EGLDisplay _display;
    /** The EGL config. */
    EGLConfig  _config;
    /** The window surface. */
    EGLSurface _surface;
    /** The EGL context. */
    EGLContext _context;
    
    /** A flag used to determine whether EGL has been initialised or not. */
    BOOL _eglInitialized;
    
    /** A handle to the vertex shader. */
    GLuint _vertexShader;
    /** A handle to the fragment shader. */
    GLuint _fragmentShader;
    /** A handle to the shader program. */
    GLuint _program;

		GLuint _colour;

		NSDate *_start;
}

/** Called by the app delegate to shutdown EGL. */
- (void)cleanup;

@end
