#ifndef _GLESCLIENT_H
#define _GLESCLIENT_H

#include <string>

#include <EGL/egl.h>
#include <GLES2/gl2.h>

class GLESClient{
public:
	GLESClient(EGLNativeWindowType window)
		: m_window(window)
		, m_elapsedTime(0)
	{}
	~GLESClient(){}
	void setVertexShaderSource(const char *shaderString){ m_vertexShaderSrc = shaderString; }
	void setFragmentShaderSource(const char *shaderString){ m_fragmentShaderSrc = shaderString; }
	bool loadShader(const GLchar *shaderString, GLuint *shader, GLuint type);
	void init();
	void cycle();
	void draw();
	void setElapsedTime(double elapsed){ m_elapsedTime = elapsed; }
private:
	void init_resources();

	EGLNativeWindowType m_window;
	std::string m_vertexShaderSrc;
	std::string m_fragmentShaderSrc;

	EGLDisplay m_display;
	EGLConfig m_config;
	EGLSurface m_surface;
	EGLContext m_context;

	bool m_eglInitialized;

	GLuint m_vertexShader;
	GLuint m_fragmentShader;
	GLuint m_program;
	GLuint m_colour;	
	GLint positionSlot, colorSlot;
	
	double m_elapsedTime;
};
#endif
