#ifndef _MAIN_H
#define _MAIN_H

#if 0
#define glErrorString(x) \
	{\
		return "FOO"; \
	}
#endif
#if 1
inline const char *glErrorString(GLenum error){
	switch(error){
		case GL_NO_ERROR:
			return "GL_NO_ERROR";
		case GL_INVALID_ENUM:
			return "GL_INVALID_ENUM";
		case GL_INVALID_VALUE:
			return "GL_INVALID_VALUE";
		case GL_INVALID_OPERATION:
			return "GL_INVALID_OPERATION";
		case GL_INVALID_FRAMEBUFFER_OPERATION:
			return "GL_INVALID_FRAMEBUFFER_OPERATION";
		case GL_OUT_OF_MEMORY:
			return "GL_OUT_OF_MEMORY";
	}
	return "GL_UNKNOWN_ERROR";
}
#endif



#define GL_CHECK(x) \
    x; \
    { \
        GLenum glError = glGetError(); \
        if(glError != GL_NO_ERROR) { \
            fprintf(stderr, "glGetError() = %i %s (0x%.8x) at line %i of %s\n", \
                glError, glErrorString(glError), glError, __LINE__, __FILE__); \
            exit(1); \
        } \
    }

#define EGL_CHECK(x) \
    x; \
    { \
        EGLint eglError = eglGetError(); \
        if(eglError != EGL_SUCCESS) { \
            fprintf(stderr, "eglGetError() = %i (0x%.8x) at line %i of %s\n", \
                eglError, eglError, __LINE__, __FILE__); \
            exit(1); \
        } \
    }



#endif
