#import <Cocoa/Cocoa.h>

#import "ARMGLESView.h"

#include "main.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// OpenGL main functions
////////////////////////////////////////////////////////////////////////////////////////////////////

void draw(){
	GLfloat vVerticies[] = {
		0.0f, 0.5f, 0.0f,
		-0.5f, -0.5f, 0.0f,
		0.5f, -0.5f, 0.0f
	};
	

	//Draw a grey background
  GL_CHECK(glClearColor(0.2, 0.2, 0.2, 1.0));
	GL_CHECK(glClear(GL_COLOR_BUFFER_BIT));

	//Load the vertext data
	glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 0, vVerticies);
	glEnableVertexAttribArray(0);

	glDrawArrays(GL_TRIANGLES, 0, 3);

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Delegate - Interaction with OSX main system
////////////////////////////////////////////////////////////////////////////////////////////////////

@interface ARMAppDelegate : NSObject <NSApplicationDelegate> {
	NSWindow *_window;
	ARMGLESView *_view;
}

@end

@implementation ARMAppDelegate


-(void)applicationWillFinishLaunching:(NSNotification *)notification{
	
	CGRect frame = CGRectMake(0,0,640,480);
	_window = [[NSWindow alloc] initWithContentRect:frame styleMask:(NSTitledWindowMask|NSMiniaturizableWindowMask|NSResizableWindowMask) backing:NSBackingStoreBuffered defer:YES];
	[_window setTitle:@"GLES Examples"];
	
	_view = [[ARMGLESView alloc] initWithFrame:frame];
	[[_window contentView] addSubview:_view];
}

-(void)applicationDidFinishLaunching:(NSNotification *)notification{
	[_window makeKeyAndOrderFront:self];
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
    /* Tell the ARMGLESView to shut down EGL */
    [_view cleanup];
	
	[_view release];
	
	[_window release];
}

@end

////////////////////////////////////////////////////////////////////////////////////////////////////
// Main entrypoint into our program
///////////////////////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
	ARMAppDelegate *delegate = [[ARMAppDelegate alloc] init];
	[NSApplication sharedApplication];
	[NSApp setDelegate:delegate];
	//XXX:Not releasing init memory
    return NSApplicationMain(argc, (const char **)argv);
}
